//
// Office.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Office: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var iDXOfficeParticipationYN: Bool?
    public var mainOfficeKeyNumeric: Double?
    public var officeAORkeyNumeric: Double?
    public var officeBrokerKeyNumeric: Double?
    public var officeKeyNumeric: Double?
    public var officeManagerKeyNumeric: Double?
    public var franchiseAffiliation: String?
    public var mainOfficeKey: String?
    public var mainOfficeMlsId: String?
    public var officeAORMlsId: String?
    public var officeAORkey: String?
    public var officeAddress1: String?
    public var officeAddress2: String?
    public var officeAssociationComments: String?
    public var officeBrokerKey: String?
    public var officeBrokerMlsId: String?
    public var officeCity: String?
    public var officeCorporateLicense: String?
    public var officeEmail: String?
    public var officeFax: String?
    public var officeKey: String?
    public var officeManagerKey: String?
    public var officeManagerMlsId: String?
    public var officeMlsId: String?
    public var officeName: String?
    public var officeNationalAssociationId: String?
    public var officePhone: String?
    public var officePhoneExt: String?
    public var officePostalCode: String?
    public var officePostalCodePlus4: String?
    public var originatingSystemID: Double?
    public var originatingSystemName: String?
    public var originatingSystemOfficeKey: String?
    public var sourceSystemID: Double?
    public var sourceSystemName: String?
    public var sourceSystemOfficeKey: String?
    public var syndicateTo: [String]?
    public var officeAOR: String?
    public var officeBranchType: String?
    public var officeCountyOrParish: String?
    public var officeStateOrProvince: String?
    public var officeStatus: String?
    public var officeType: String?
    public var socialMediaType: String?
    public var syndicateAgentOption: String?
    public var modificationTimestamp: Date?
    public var originalEntryTimestamp: Date?
    public var officeBroker: Member?
    public var officeManager: Member?
    public var mainOffice: Office?
    public var originatingSystem: OUID?
    public var sourceSystem: OUID?
    public var members: [Member]?
    public var offices: [Office]?
    public var buyerOfficeProperties: [Property]?
    public var coBuyerOfficeProperties: [Property]?
    public var coListOfficeProperties: [Property]?
    public var listOfficeProperties: [Property]?

    public init(id: Int? = nil, iDXOfficeParticipationYN: Bool? = nil, mainOfficeKeyNumeric: Double? = nil, officeAORkeyNumeric: Double? = nil, officeBrokerKeyNumeric: Double? = nil, officeKeyNumeric: Double? = nil, officeManagerKeyNumeric: Double? = nil, franchiseAffiliation: String? = nil, mainOfficeKey: String? = nil, mainOfficeMlsId: String? = nil, officeAORMlsId: String? = nil, officeAORkey: String? = nil, officeAddress1: String? = nil, officeAddress2: String? = nil, officeAssociationComments: String? = nil, officeBrokerKey: String? = nil, officeBrokerMlsId: String? = nil, officeCity: String? = nil, officeCorporateLicense: String? = nil, officeEmail: String? = nil, officeFax: String? = nil, officeKey: String? = nil, officeManagerKey: String? = nil, officeManagerMlsId: String? = nil, officeMlsId: String? = nil, officeName: String? = nil, officeNationalAssociationId: String? = nil, officePhone: String? = nil, officePhoneExt: String? = nil, officePostalCode: String? = nil, officePostalCodePlus4: String? = nil, originatingSystemID: Double? = nil, originatingSystemName: String? = nil, originatingSystemOfficeKey: String? = nil, sourceSystemID: Double? = nil, sourceSystemName: String? = nil, sourceSystemOfficeKey: String? = nil, syndicateTo: [String]? = nil, officeAOR: String? = nil, officeBranchType: String? = nil, officeCountyOrParish: String? = nil, officeStateOrProvince: String? = nil, officeStatus: String? = nil, officeType: String? = nil, socialMediaType: String? = nil, syndicateAgentOption: String? = nil, modificationTimestamp: Date? = nil, originalEntryTimestamp: Date? = nil, officeBroker: Member? = nil, officeManager: Member? = nil, mainOffice: Office? = nil, originatingSystem: OUID? = nil, sourceSystem: OUID? = nil, members: [Member]? = nil, offices: [Office]? = nil, buyerOfficeProperties: [Property]? = nil, coBuyerOfficeProperties: [Property]? = nil, coListOfficeProperties: [Property]? = nil, listOfficeProperties: [Property]? = nil) {
        self.id = id
        self.iDXOfficeParticipationYN = iDXOfficeParticipationYN
        self.mainOfficeKeyNumeric = mainOfficeKeyNumeric
        self.officeAORkeyNumeric = officeAORkeyNumeric
        self.officeBrokerKeyNumeric = officeBrokerKeyNumeric
        self.officeKeyNumeric = officeKeyNumeric
        self.officeManagerKeyNumeric = officeManagerKeyNumeric
        self.franchiseAffiliation = franchiseAffiliation
        self.mainOfficeKey = mainOfficeKey
        self.mainOfficeMlsId = mainOfficeMlsId
        self.officeAORMlsId = officeAORMlsId
        self.officeAORkey = officeAORkey
        self.officeAddress1 = officeAddress1
        self.officeAddress2 = officeAddress2
        self.officeAssociationComments = officeAssociationComments
        self.officeBrokerKey = officeBrokerKey
        self.officeBrokerMlsId = officeBrokerMlsId
        self.officeCity = officeCity
        self.officeCorporateLicense = officeCorporateLicense
        self.officeEmail = officeEmail
        self.officeFax = officeFax
        self.officeKey = officeKey
        self.officeManagerKey = officeManagerKey
        self.officeManagerMlsId = officeManagerMlsId
        self.officeMlsId = officeMlsId
        self.officeName = officeName
        self.officeNationalAssociationId = officeNationalAssociationId
        self.officePhone = officePhone
        self.officePhoneExt = officePhoneExt
        self.officePostalCode = officePostalCode
        self.officePostalCodePlus4 = officePostalCodePlus4
        self.originatingSystemID = originatingSystemID
        self.originatingSystemName = originatingSystemName
        self.originatingSystemOfficeKey = originatingSystemOfficeKey
        self.sourceSystemID = sourceSystemID
        self.sourceSystemName = sourceSystemName
        self.sourceSystemOfficeKey = sourceSystemOfficeKey
        self.syndicateTo = syndicateTo
        self.officeAOR = officeAOR
        self.officeBranchType = officeBranchType
        self.officeCountyOrParish = officeCountyOrParish
        self.officeStateOrProvince = officeStateOrProvince
        self.officeStatus = officeStatus
        self.officeType = officeType
        self.socialMediaType = socialMediaType
        self.syndicateAgentOption = syndicateAgentOption
        self.modificationTimestamp = modificationTimestamp
        self.originalEntryTimestamp = originalEntryTimestamp
        self.officeBroker = officeBroker
        self.officeManager = officeManager
        self.mainOffice = mainOffice
        self.originatingSystem = originatingSystem
        self.sourceSystem = sourceSystem
        self.members = members
        self.offices = offices
        self.buyerOfficeProperties = buyerOfficeProperties
        self.coBuyerOfficeProperties = coBuyerOfficeProperties
        self.coListOfficeProperties = coListOfficeProperties
        self.listOfficeProperties = listOfficeProperties
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case iDXOfficeParticipationYN = "IDXOfficeParticipationYN"
        case mainOfficeKeyNumeric = "MainOfficeKeyNumeric"
        case officeAORkeyNumeric = "OfficeAORkeyNumeric"
        case officeBrokerKeyNumeric = "OfficeBrokerKeyNumeric"
        case officeKeyNumeric = "OfficeKeyNumeric"
        case officeManagerKeyNumeric = "OfficeManagerKeyNumeric"
        case franchiseAffiliation = "FranchiseAffiliation"
        case mainOfficeKey = "MainOfficeKey"
        case mainOfficeMlsId = "MainOfficeMlsId"
        case officeAORMlsId = "OfficeAORMlsId"
        case officeAORkey = "OfficeAORkey"
        case officeAddress1 = "OfficeAddress1"
        case officeAddress2 = "OfficeAddress2"
        case officeAssociationComments = "OfficeAssociationComments"
        case officeBrokerKey = "OfficeBrokerKey"
        case officeBrokerMlsId = "OfficeBrokerMlsId"
        case officeCity = "OfficeCity"
        case officeCorporateLicense = "OfficeCorporateLicense"
        case officeEmail = "OfficeEmail"
        case officeFax = "OfficeFax"
        case officeKey = "OfficeKey"
        case officeManagerKey = "OfficeManagerKey"
        case officeManagerMlsId = "OfficeManagerMlsId"
        case officeMlsId = "OfficeMlsId"
        case officeName = "OfficeName"
        case officeNationalAssociationId = "OfficeNationalAssociationId"
        case officePhone = "OfficePhone"
        case officePhoneExt = "OfficePhoneExt"
        case officePostalCode = "OfficePostalCode"
        case officePostalCodePlus4 = "OfficePostalCodePlus4"
        case originatingSystemID = "OriginatingSystemID"
        case originatingSystemName = "OriginatingSystemName"
        case originatingSystemOfficeKey = "OriginatingSystemOfficeKey"
        case sourceSystemID = "SourceSystemID"
        case sourceSystemName = "SourceSystemName"
        case sourceSystemOfficeKey = "SourceSystemOfficeKey"
        case syndicateTo = "SyndicateTo"
        case officeAOR = "OfficeAOR"
        case officeBranchType = "OfficeBranchType"
        case officeCountyOrParish = "OfficeCountyOrParish"
        case officeStateOrProvince = "OfficeStateOrProvince"
        case officeStatus = "OfficeStatus"
        case officeType = "OfficeType"
        case socialMediaType = "SocialMediaType"
        case syndicateAgentOption = "SyndicateAgentOption"
        case modificationTimestamp = "ModificationTimestamp"
        case originalEntryTimestamp = "OriginalEntryTimestamp"
        case officeBroker = "OfficeBroker"
        case officeManager = "OfficeManager"
        case mainOffice = "MainOffice"
        case originatingSystem = "OriginatingSystem"
        case sourceSystem = "SourceSystem"
        case members = "Members"
        case offices = "Offices"
        case buyerOfficeProperties = "BuyerOfficeProperties"
        case coBuyerOfficeProperties = "CoBuyerOfficeProperties"
        case coListOfficeProperties = "CoListOfficeProperties"
        case listOfficeProperties = "ListOfficeProperties"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(iDXOfficeParticipationYN, forKey: .iDXOfficeParticipationYN)
        try container.encodeIfPresent(mainOfficeKeyNumeric, forKey: .mainOfficeKeyNumeric)
        try container.encodeIfPresent(officeAORkeyNumeric, forKey: .officeAORkeyNumeric)
        try container.encodeIfPresent(officeBrokerKeyNumeric, forKey: .officeBrokerKeyNumeric)
        try container.encodeIfPresent(officeKeyNumeric, forKey: .officeKeyNumeric)
        try container.encodeIfPresent(officeManagerKeyNumeric, forKey: .officeManagerKeyNumeric)
        try container.encodeIfPresent(franchiseAffiliation, forKey: .franchiseAffiliation)
        try container.encodeIfPresent(mainOfficeKey, forKey: .mainOfficeKey)
        try container.encodeIfPresent(mainOfficeMlsId, forKey: .mainOfficeMlsId)
        try container.encodeIfPresent(officeAORMlsId, forKey: .officeAORMlsId)
        try container.encodeIfPresent(officeAORkey, forKey: .officeAORkey)
        try container.encodeIfPresent(officeAddress1, forKey: .officeAddress1)
        try container.encodeIfPresent(officeAddress2, forKey: .officeAddress2)
        try container.encodeIfPresent(officeAssociationComments, forKey: .officeAssociationComments)
        try container.encodeIfPresent(officeBrokerKey, forKey: .officeBrokerKey)
        try container.encodeIfPresent(officeBrokerMlsId, forKey: .officeBrokerMlsId)
        try container.encodeIfPresent(officeCity, forKey: .officeCity)
        try container.encodeIfPresent(officeCorporateLicense, forKey: .officeCorporateLicense)
        try container.encodeIfPresent(officeEmail, forKey: .officeEmail)
        try container.encodeIfPresent(officeFax, forKey: .officeFax)
        try container.encodeIfPresent(officeKey, forKey: .officeKey)
        try container.encodeIfPresent(officeManagerKey, forKey: .officeManagerKey)
        try container.encodeIfPresent(officeManagerMlsId, forKey: .officeManagerMlsId)
        try container.encodeIfPresent(officeMlsId, forKey: .officeMlsId)
        try container.encodeIfPresent(officeName, forKey: .officeName)
        try container.encodeIfPresent(officeNationalAssociationId, forKey: .officeNationalAssociationId)
        try container.encodeIfPresent(officePhone, forKey: .officePhone)
        try container.encodeIfPresent(officePhoneExt, forKey: .officePhoneExt)
        try container.encodeIfPresent(officePostalCode, forKey: .officePostalCode)
        try container.encodeIfPresent(officePostalCodePlus4, forKey: .officePostalCodePlus4)
        try container.encodeIfPresent(originatingSystemID, forKey: .originatingSystemID)
        try container.encodeIfPresent(originatingSystemName, forKey: .originatingSystemName)
        try container.encodeIfPresent(originatingSystemOfficeKey, forKey: .originatingSystemOfficeKey)
        try container.encodeIfPresent(sourceSystemID, forKey: .sourceSystemID)
        try container.encodeIfPresent(sourceSystemName, forKey: .sourceSystemName)
        try container.encodeIfPresent(sourceSystemOfficeKey, forKey: .sourceSystemOfficeKey)
        try container.encodeIfPresent(syndicateTo, forKey: .syndicateTo)
        try container.encodeIfPresent(officeAOR, forKey: .officeAOR)
        try container.encodeIfPresent(officeBranchType, forKey: .officeBranchType)
        try container.encodeIfPresent(officeCountyOrParish, forKey: .officeCountyOrParish)
        try container.encodeIfPresent(officeStateOrProvince, forKey: .officeStateOrProvince)
        try container.encodeIfPresent(officeStatus, forKey: .officeStatus)
        try container.encodeIfPresent(officeType, forKey: .officeType)
        try container.encodeIfPresent(socialMediaType, forKey: .socialMediaType)
        try container.encodeIfPresent(syndicateAgentOption, forKey: .syndicateAgentOption)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(originalEntryTimestamp, forKey: .originalEntryTimestamp)
        try container.encodeIfPresent(officeBroker, forKey: .officeBroker)
        try container.encodeIfPresent(officeManager, forKey: .officeManager)
        try container.encodeIfPresent(mainOffice, forKey: .mainOffice)
        try container.encodeIfPresent(originatingSystem, forKey: .originatingSystem)
        try container.encodeIfPresent(sourceSystem, forKey: .sourceSystem)
        try container.encodeIfPresent(members, forKey: .members)
        try container.encodeIfPresent(offices, forKey: .offices)
        try container.encodeIfPresent(buyerOfficeProperties, forKey: .buyerOfficeProperties)
        try container.encodeIfPresent(coBuyerOfficeProperties, forKey: .coBuyerOfficeProperties)
        try container.encodeIfPresent(coListOfficeProperties, forKey: .coListOfficeProperties)
        try container.encodeIfPresent(listOfficeProperties, forKey: .listOfficeProperties)
    }
}

